XPathFactory (XML Standard API)
Date: 2018-10-17

javax.xml.xpath

## Class XPathFactory

- java.lang.Object
- - javax.xml.xpath.XPathFactory

-     public abstract class XPathFactory
      extends java.lang.Object

  An `XPathFactory` instance can be used to create `XPath` objects.

  See `newInstance(String uri)` for lookup mechanism.

  Since:
    1.5
  Version:
    $Revision: 888889 $, $Date: 2009-12-09 12:43:18 -0500 (Wed, 09 Dec 2009) $
  Author:
    Norman Walsh, Jeff Suttor

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DEFAULT_OBJECT_MODEL_URI` Default Object Model URI.
    `static java.lang.String` | `DEFAULT_PROPERTY_NAME` The default property name according to the JAXP spec.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `XPathFactory()` Protected constructor as `newInstance()`, `newInstance(String uri)` or `newInstance(String uri, String factoryClassName, ClassLoader classLoader)` should be used to create a new instance of an `XPathFactory`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract boolean` | `getFeature(java.lang.String name)` Get the state of the named feature.
    `abstract boolean` | `isObjectModelSupported(java.lang.String objectModel)` Is specified object model supported by this `XPathFactory`?
    `static XPathFactory` | `newInstance()` Get a new `XPathFactory` instance using the default object model, `DEFAULT_OBJECT_MODEL_URI`, the W3C DOM.
    `static XPathFactory` | `newInstance(java.lang.String uri)` Get a new `XPathFactory` instance using the specified object model.
    `static XPathFactory` | `newInstance(java.lang.String uri, java.lang.String factoryClassName, java.lang.ClassLoader classLoader)`
    `abstract XPath` | `newXPath()` Return a new `XPath` using the underlying object model determined when the `XPathFactory` was instantiated.
    `abstract void` | `setFeature(java.lang.String name, boolean value)` Set a feature for this `XPathFactory` and `XPath`s created by this factory.
    `abstract void` | `setXPathFunctionResolver(XPathFunctionResolver resolver)` Establish a default function resolver.
    `abstract void` | `setXPathVariableResolver(XPathVariableResolver resolver)` Establish a default variable resolver.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PROPERTY_NAME

          public static final java.lang.String DEFAULT_PROPERTY_NAME

      The default property name according to the JAXP spec.

      See Also:
        Constant Field Values

    - #### DEFAULT_OBJECT_MODEL_URI

          public static final java.lang.String DEFAULT_OBJECT_MODEL_URI

      Default Object Model URI.

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### XPathFactory

          protected XPathFactory()

      Protected constructor as `newInstance()`, `newInstance(String uri)` or `newInstance(String uri, String factoryClassName, ClassLoader classLoader)` should be used to create a new instance of an `XPathFactory`.

  - ### Method Detail

    - #### newInstance

          public static final XPathFactory newInstance()

      Get a new `XPathFactory` instance using the default object model, `DEFAULT_OBJECT_MODEL_URI`, the W3C DOM.

      This method is functionally equivalent to:

             newInstance(DEFAULT_OBJECT_MODEL_URI)

      Since the implementation for the W3C DOM is always available, this method will never fail.

      Returns:
        Instance of an `XPathFactory`.

    - #### newInstance

          public static final XPathFactory newInstance(java.lang.String uri)
                                                throws XPathFactoryConfigurationException

      Get a new `XPathFactory` instance using the specified object model.

      To find a `XPathFactory` object, this method looks the following places in the following order where "the class loader" refers to the context class loader:

      1. If the system property `DEFAULT_PROPERTY_NAME` + ":uri" is present, where uri is the parameter to this method, then its value is read as a class name. The method will try to create a new instance of this class by using the class loader, and returns it if it is successfully created.
      2. ${java.home}/lib/jaxp.properties is read and the value associated with the key being the system property above is looked for. If present, the value is processed just like above.
      3. The class loader is asked for service provider provider-configuration files matching `javax.xml.xpath.XPathFactory` in the resource directory META-INF/services. See the JAR File Specification for file format and parsing rules. Each potential service provider is required to implement the method:

                    isObjectModelSupported(String objectModel)

         The first service provider found in class loader order that supports the specified object model is returned.
      4. Platform default `XPathFactory` is located in a platform specific way. There must be a platform default XPathFactory for the W3C DOM, i.e. `DEFAULT_OBJECT_MODEL_URI`.

      If everything fails, an `XPathFactoryConfigurationException` will be thrown.

      Tip for Trouble-shooting:

      See `Properties.load(java.io.InputStream)` for exactly how a property file is parsed. In particular, colons ':' need to be escaped in a property file, so make sure the URIs are properly escaped in it. For example:

             http\://java.sun.com/jaxp/xpath/dom=org.acme.DomXPathFactory

      Parameters:
        `uri` - Identifies the underlying object model. The specification only defines the URI `DEFAULT_OBJECT_MODEL_URI`, `http://java.sun.com/jaxp/xpath/dom` for the W3C DOM, the org.w3c.dom package, and implementations are free to introduce other URIs for other object models.
      Returns:
        Instance of an `XPathFactory`.
      Throws:
        `XPathFactoryConfigurationException` - If the specified object model is unavailable.
        `java.lang.NullPointerException` - If `uri` is `null`.
        `java.lang.IllegalArgumentException` - If `uri.length() == 0`.

    - #### newInstance

          public static XPathFactory newInstance(java.lang.String uri,
                                                 java.lang.String factoryClassName,
                                                 java.lang.ClassLoader classLoader)
                                          throws XPathFactoryConfigurationException

      Returns:
        Instance of an `XPathFactory`.
      Throws:
        `XPathFactoryConfigurationException` - If the specified object model is unavailable.
        `java.lang.NullPointerException` - If `uri` is `null`.
        `java.lang.IllegalArgumentException` - If `uri.length() == 0`.

    - #### isObjectModelSupported

          public abstract boolean isObjectModelSupported(java.lang.String objectModel)

      Is specified object model supported by this `XPathFactory`?

      Parameters:
        `objectModel` - Specifies the object model which the returned `XPathFactory` will understand.
      Returns:
        `true` if `XPathFactory` supports `objectModel`, else `false`.
      Throws:
        `java.lang.NullPointerException` - If `objectModel` is `null`.
        `java.lang.IllegalArgumentException` - If `objectModel.length() == 0`.

    - #### setFeature

          public abstract void setFeature(java.lang.String name,
                                          boolean value)
                                   throws XPathFactoryConfigurationException

      Set a feature for this `XPathFactory` and `XPath`s created by this factory.

      Feature names are fully qualified `URI`s. Implementations may define their own features. An `XPathFactoryConfigurationException` is thrown if this `XPathFactory` or the `XPath`s it creates cannot support the feature. It is possible for an `XPathFactory` to expose a feature value but be unable to change its state.

      All implementations are required to support the `XMLConstants.FEATURE_SECURE_PROCESSING` feature. When the feature is `true`, any reference to an external function is an error. Under these conditions, the implementation must not call the `XPathFunctionResolver` and must throw an `XPathFunctionException`.

      Parameters:
        `name` - Feature name.
        `value` - Is feature state `true` or `false`.
      Throws:
        `XPathFactoryConfigurationException` - if this `XPathFactory` or the `XPath`s it creates cannot support this feature.
        `java.lang.NullPointerException` - if `name` is `null`.

    - #### getFeature

          public abstract boolean getFeature(java.lang.String name)
                                      throws XPathFactoryConfigurationException

      Get the state of the named feature.

      Feature names are fully qualified `URI`s. Implementations may define their own features. An `XPathFactoryConfigurationException` is thrown if this `XPathFactory` or the `XPath`s it creates cannot support the feature. It is possible for an `XPathFactory` to expose a feature value but be unable to change its state.

      Parameters:
        `name` - Feature name.
      Returns:
        State of the named feature.
      Throws:
        `XPathFactoryConfigurationException` - if this `XPathFactory` or the `XPath`s it creates cannot support this feature.
        `java.lang.NullPointerException` - if `name` is `null`.

    - #### setXPathVariableResolver

          public abstract void setXPathVariableResolver(XPathVariableResolver resolver)

      Establish a default variable resolver.

      Any `XPath` objects constructed from this factory will use the specified resolver by default.

      A `NullPointerException` is thrown if `resolver` is `null`.

      Parameters:
        `resolver` - Variable resolver.
      Throws:
        `java.lang.NullPointerException` - If `resolver` is `null`.

    - #### setXPathFunctionResolver

          public abstract void setXPathFunctionResolver(XPathFunctionResolver resolver)

      Establish a default function resolver.

      Any `XPath` objects constructed from this factory will use the specified resolver by default.

      A `NullPointerException` is thrown if `resolver` is `null`.

      Parameters:
        `resolver` - XPath function resolver.
      Throws:
        `java.lang.NullPointerException` - If `resolver` is `null`.

    - #### newXPath

          public abstract XPath newXPath()

      Return a new `XPath` using the underlying object model determined when the `XPathFactory` was instantiated.

      Returns:
        New instance of an `XPath`.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.